package com.google.gwt.query.client.css;

import com.google.gwt.dom.client.Style;
import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.GWT;

/**
 * This property specifies the content height of boxes generated by block-level,
 * inline-block and replaced elements.
 *
 * This property does not apply to non-replaced inline-level elements. See the
 * section on computing heights and margins for non-replaced inline elements for
 * the rules used instead.
 */
public class Height implements TakesLength, TakesPercentage {

  public Height() {
  }

  public static void init() {
    CSS.HEIGHT = new Height();
  }

  public void set(Style s, Length value) {
    s.setProperty("height", value.value());
  }

  public String get(Style s) {
    return s.getProperty("height");
  }

  public void setLength(Style s, Length p) {
    s.setProperty("height", p.value());
  }

  public void setPercentage(Style s, Percentage p) {
    s.setProperty("height", p.value());
  }
}